libmsn: MSN::P2P Class Reference

libmsn 4.2.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Public Attributes
MSN::P2P Class Reference

`#include <p2p.h>`

List of all members.

## Classes
struct | p2pPacket
struct | p2pSession
## Public Types
enum | { DIRECTION_SENDING = 0, DIRECTION_RECEIVING = 1 }
enum | { STEP_INVITATION_SENT, STEP_ACK_INVITATION_SENT, STEP_200OK_SENT, STEP_200OK_ACK_SENT, STEP_603DECLINE_SENT, STEP_603DECLINE_ACK_SENT, STEP_DC_INVITE_SENT, STEP_DC_INVITE_ACK_SENT, STEP_DC_200OK_SENT, STEP_DC_200OKACK_SENT, STEP_DATA_PREPARATION_SENT, STEP_DATA_PREPARATION_ACK, STEP_SENDING, STEP_RECEIVING, STEP_RECEIVING_FINISHED, STEP_DATA_TRANSFER_ACK, STEP_BYE_SENT, STEP_BYE_ACK }
enum | p2pTransferObj { APP_NONE = 0, APP_WEBCAM = 4, APP_FILE_TRANSFER = 2, APP_DISPLAY_PICTURE = 1, APP_EMOTICON = 11, APP_DISPLAY_PICTURE2 = 12, APP_VOICE_CLIP = 20, APP_WINK = 98, APP_INK = 99 }
enum | { FLAG_NOP = 0x0, FLAG_ACK = 0x2, FLAG_ERROR = 0x8, FLAG_DATA_EMOTICONS = 0x20, FLAG_DATA_PICTURE = 0x20, FLAG_FILE_DATA = 0x01000030, FLAG_FILE_DATA2 = 0x01000020 }
typedef void(P2P::* | P2PCallbacks )(MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
## Public Member Functions
virtual void | addCallback (P2PCallbacks, unsigned int sessionID, unsigned int ackID)
virtual void | removeCallback (unsigned int ackID)
void | sendFile (MSN::SwitchboardServerConnection &conn, MSN::fileTransferInvite ft)
void | handleP2Pmessage (MSN::SwitchboardServerConnection &conn, std::vector< std::string > &args, std::string mime, std::string body)
void | sendACK (MSN::SwitchboardServerConnection &conn, p2pPacket &packet, p2pSession &session)
void | sendP2PPacket (MSN::SwitchboardServerConnection &conn, p2pPacket &packet, p2pSession &session)
void | sendP2PData (MSN::SwitchboardServerConnection &conn, p2pSession &session, p2pPacket &packet)
void | receiveP2PData (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_negotiation (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_INVITE (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_603Decline (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_INVITE_ACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_200OK (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_BYE (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | send_200OK (MSN::SwitchboardServerConnection &conn, p2pSession &session, std::string body)
void | send_BYE (MSN::SwitchboardServerConnection &conn, p2pPacket &packet, p2pSession &session)
void | send_603Decline (MSN::SwitchboardServerConnection &conn, p2pSession &session)
void | handle_p2pACK (MSN::SwitchboardServerConnection &conn, p2pPacket &packet)
void | handle_200OKACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_603DeclineACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_DataPreparationACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_DataACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_BYEACK (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, p2pPacket &packet)
void | handle_MSGACKReceived (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string fromPassport)
void | handle_fileTransferResponse (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, bool response)
void | handle_session_changes (MSN::SwitchboardServerConnection &conn, p2pPacket &packet, p2pSession &session)
void | requestFile (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject, p2pTransferObj obj)
void | requestDisplayPicture (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject)
void | sendInk (MSN::SwitchboardServerConnection &conn, std::string image)
void | cancelTransfer (MSN::SwitchboardServerConnection &conn, unsigned int sessionID)
void | requestEmoticon (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject, std::string alias)
void | requestVoiceClip (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject)
void | requestWink (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject)
void | requestInk (MSN::SwitchboardServerConnection &conn, unsigned int sessionID, std::string filename, std::string msnobject)
## Public Attributes
unsigned int | rand_helper
std::map< unsigned int, std::pair< P2PCallbacks, unsigned int > > | callbacks
std::map< unsigned int, p2pPacket > | pendingP2PMsg
std::map< unsigned int, p2pSession > | startedSessions

## Detailed Description

Manages all p2p communication.

The documentation for this class was generated from the following files:

- /home/salem/libmsn/tags/libmsn-4.2/msn/p2p.h
- /home/salem/libmsn/tags/libmsn-4.2/msn/p2p.cpp

All Classes Namespaces Functions Variables Enumerations Enumerator